	TITLE   sh0.asm
	NAME    sh0
	.8087

; MS-DOS SHELL - Swapper
;
; MS-DOS SHELL - Copyright (c) 1989 Data Logic Limited.
;
; MS-DOS SHELL - Copyright (c) 1990 Data Logic Limited
;
; This code is subject to the following copyright restrictions:
;
; 1.  Redistribution and use in source and binary forms are permitted
;     provided that the above copyright notice is duplicated in the
;     source form and the copyright notice in file sh6.c is displayed
;     on entry to the program.
;
; 2.  The sources (or parts thereof) or objects generated from the sources
;     (or parts of sources) cannot be sold under any circumstances.
;
;    $Header: sh0.asm 1.1 90/01/25 13:43:36 MS_user Exp $
;
;    $Log:	sh0.asm $
;	Revision 1.1  90/01/25  13:43:36  MS_user
;	Initial revision
;	
;

;
; Segment declarations
;

SH0_TEXT	segment word public 'CODE'
SH0_TEXT	ends

_DATA		segment word public 'DATA'
_DATA		ends

CONST		segment word public 'CONST'
CONST		ends

_BSS		segment word public 'BSS'
_BSS		ends

DGROUP		group	CONST, _BSS, _DATA

;
; Declare external functions and data
;
	extrn	_raise:far
	extrn	__maperror:far
	extrn	_errno:word
	extrn	__psp:word

;
; Start of the spawn function
;

SH0_TEXT	segment
		assume  cs: SH0_TEXT, ds: NOTHING, ss: DGROUP

;
; For this function, all the code and data space are in the code space
;
		public	_cmd_line
		public	_path_line
		public	_SW_intr
		public	_SW_Blocks
		public	_SW_fp
		public	_SW_I0_V_BX
		public	_SW_I0_V_ES
		public	_SW_I23_V_ES
		public	_SW_I23_V_BX
		public	_SW_EMstart
		public	_SW_Mode
		public	_SW_EMSFrame

_cmd_line	db	129 dup (?)	; Command line
_path_line	db	80 dup (?)	; Path line
_SW_Blocks	dw	0		; Number of blocks to read/write
_SW_fp		dw	0		; File ID
_SW_I23_V_ES	dw	0		; Interrupt 23 address
_SW_I23_V_BX	dw	0
_SW_I0_V_BX	dw	0		; Our Interrupt zero value
_SW_I0_V_ES	dw	0
_SW_EMstart	dd	0100000H	; Default Extended Mem start
_SW_Mode	dw	0		; Type of swapping to do
					;   1 - disk
					;   2 - Extended memory
					;   3 - Expanded memory
_SW_EMSFrame	dw	0		; EMS Frame segment
_SW_intr	dw	0		; Interrupt 23 detected.


;
; Some addition variables
;

SW_LMstart	dd	0		; Low Mem start for Extended Mem swap
N_mcb		dw	0		; Start write address
Result		dw	0		; Return value
InShell		db	0		; In shell flag for Interrupt 23

;
; Stack save pointers
;

S_ss		dw	0			; Save Stack pointers
S_sp		dw	0
S_di		dw	0			; Save DI, SI
S_si		dw	0
S_ds		dw	0			; Save the original DS

;
; Two blank FCB
;

FCB1		dw	16	dup (?)
FCB2		dw	16	dup (?)

;
; Extended Memory Global Descriptor tables
;

GD_table	equ	$
GDT_Dummy	dw	4	dup (0)		; Dummy
GDT_self	dw	4	dup (0)		; For self
GDT_src		equ	$			; Source
		dw	04000H			; Length - 16K bytes
GDT_src_low	dw	0			;     Low Order address
GDT_src_high	db	0			;     High Order address
		db	093h			;     Access Rights
		dw	0			;     Reserved
GDT_dest	equ	$			; Destination
		dw	04000H			;     Length - 16K bytes
GDT_dest_low	dw	0			;     Low Order address
GDT_dest_high	db	0			;     High Order address
		db	093h			;     Access Rights
		dw	0			;     Reserved
GDT_bios	dw	4	dup (0)		; Bios
GDT_stack	dw	4	dup (0)		; Stack

;
; Execute interrupt structure
;

exec_parms	equ	$
exec_env	dw	0
		dw	offset _cmd_line	; Command line address
exec_cseg	dw	?
		dw	offset FCB1		; FCB1 address
exec_f1seg	dw	?
		dw	offset FCB2		; FCB1 address
exec_f2seg	dw	?

Swap_PANIC	db	'PANIC: Swap file re-load error - REBOOT', 0aH, 0dH
		db	'$'

Swap_DZERO	db	'PANIC: Divide by zero', 0aH, 0dH
		db	'$'

;
; OK - exec requires a local stack, cause some programs overwrite it
;
		even
		db	398 dup (0)
Local_Stack:
		dw	0

;
; Code starts
;
	public	_SA_spawn

_SA_spawn	proc	far

	push	bp
	mov	bp, sp

;
; Entry Offsets
;
;	Environment      = 6
;

	mov	word ptr cs:S_di, di		; Save registers
	mov	word ptr cs:S_si, si
	mov	word ptr cs:S_ds, ds

;
; Set up to ingnore Control C interrupts
;

	push	ds
	mov	ax, 02523H		; Set Control C Interrupt
	mov	dx, offset SA_IRET
	push	cs
	pop	ds
	mov	byte ptr cs:InShell, 0	; Set In shell flag for Interrupt 23
	int	021H

	mov	ax, 02500H		; Set Divide Zero Interrupt
	mov	dx, offset SA_DZERO
	push	cs
	pop	ds
	int	021H

	pop	ds

;
; Save the length of the current MCB block;
;

	mov	ax, word ptr ds:__psp
	dec	ax
	mov	word ptr cs:N_mcb, ax		; Save MCB address for swap out

; Calculate low mem start for extended memory

	mov	bx, ax				; Save copy
	mov	cl, 4				; mult low order by 16
	shl	ax, cl
	mov	word ptr cs:SW_LMstart, ax	; Save low order
	mov	cl, 12				; div by 16 ** 3
	shr	bx, cl
	mov	byte ptr cs:SW_LMstart + 2, bl	; Save low order

;
; Set up Environment segment in execute structure
;

	mov	bx, cs
	mov	ax, offset Env_OWrite
	mov	cl, 4
	shr	ax, cl
	add	ax, bx
	mov	word ptr cs:exec_env, ax	; Save Env seg.

;
; Set up rest of execute structure
;

	mov	word ptr cs:exec_cseg, cs	; Command line address
	mov	word ptr cs:exec_f1seg, cs	; FCB 1 address
	mov	word ptr cs:exec_f2seg, cs	; FCB 2 address

;
; Generate the FCBs
;

	mov	ax, cs		; Set up segments
	mov	ds, ax
	mov	es, ax

	mov	ax, 02901H	; Set up FCB interrupt
	mov	si, offset _cmd_line + 1
	mov	di, offset FCB1	; FCB 1;

	int	021H		; Execute the interrupt

	mov	ax, cs		; Set up segment
	mov	es, ax

	mov	ax, 02901H	; Reset AX cause errors are ignored
	mov	di, offset FCB2	; FCB 2;

	int	021H		; Execute the interrupt

;
; Copy out to the swap file
;

	mov	si, word ptr cs:_SW_Blocks	; Load Number of blocks to read
	mov	bx, word ptr cs:_SW_fp		; Load file handler

; load up extended memory GDT for destination

	mov	ax, word ptr cs:_SW_EMstart
	mov	dl, byte ptr cs:_SW_EMstart + 2
	call	$GDT_dest_load

;
; set up DS register with start of start copy
;

	mov	ax, word ptr cs:N_mcb		; Load the start address
	mov	ds, ax

	mov	ax, word ptr cs:SW_LMstart 	; Load Full start address
	mov	dl, byte ptr cs:SW_LMstart + 2
	call	$GDT_src_load

;
; Check for end of copy - BX contains the file handler for disk write
;

$Write_loop:
	or	si, si
	je	$Write_Complete

; OK - Copy next 0x4000 bytes - switch on device

	mov	ax, word ptr cs: _SW_Mode
	dec	ax
	jz	$Write_disk
	dec	ax
	jz	$W_extend
	jmp	$W_expand

; Write to disk

$Write_disk:
	mov	ax, 04000H		; Set up to write
	mov	cx, ax			; Load count
	xor	dx, dx			; Clear start address
	push	bx			; Save FP
	push	si			; Save count and Data Segment

	int	021H			; Write the data

	pop	si			; Restore Regs
	pop	bx
	jc	$Write_error		; NO - abort

$Write_Incr:
	dec	si			; Decrement block count
	mov	ax, ds			; Increment offset
	add	ax, 0400H
	mov	ds, ax
	jmp	$Write_loop

; Write to extended memory

$W_extend:
	call	$Write_extend
	jc	$Write_error		; NO - abort

	dec	si			; Decrement block count
	call	$Inc_Extend
	jmp	$Write_loop

; Write to expanded memory
;	BX - handler
;	SI - count
;	DS - source segment
;
$W_expand:
	call	$map_ems_page		; Map in the current EMS page
	jnz	$Write_error

	push	ds			; Save DS and SI
	push	si
	mov	es, word ptr cs:_SW_EMSFrame	; Set Dest Seg
	xor	si, si			; Clear start
	xor	di, di
	mov	cx, 02000H		; move 16K
	pushf				; Save direction flag
	cld
    rep movsw
	popf				; Restore direction flag
	pop	si			; And DS, SI
	pop	ds
	jmp	$Write_Incr		; Increment DS and dec SI

;
; Error - abort.  The error code is in AH.
;

$Write_error:
	mov	ds, word ptr cs:S_ds	; Restore DS
	mov	al, ah
	xor	ah, ah
	mov	word ptr ds:_errno, ax	; Save error code
	mov	ax, 0FFFEH
	jmp	$SA_spawn_Exit		; Exit

;
; Swap file is now written, set up environment
;
$Write_Complete:
	mov	ds, word ptr cs:exec_env	; Load Env seg.
	xor	si, si				; Clear start offset

;
; Copy into Env Seg
;

$Copy_Env:
	les	bx, dword ptr ss:[bp + 6]	; Check for end of loop
	mov	ax, word ptr es:[bx + 0]
	or	ax, word ptr es:[bx + 2]
	je	$Copy_End

;
; Save start address
;
	add	word ptr ss:[bp + 6], 4		; Increment environment by 4

	mov	cx, word ptr es:[bx + 0]	; Load address of cur Env string
	mov	ax, word ptr es:[bx + 2]	; into es:bx
	mov	es, ax
	mov	bx, cx

;
; Copy this value
;

$Copy_Val:
	mov	al, byte ptr es:[bx]	; Copy across
	mov	byte ptr ds:[si], al
	inc	bx			; Increment pointers
	inc	si
	or	al, al
	jne	$Copy_Val
	jmp	$Copy_Env

;
; Set up exec parameter block	 - DS is on stack
;
$Copy_End:
	xor	ax, ax
	mov	word ptr ds:[si], ax	; Terminate environment
	add	si, 2

;
; Set up new program length
;
	add	si, 16			; Round up paras
	mov	dx, si			; Save end offset in DX
	mov	bx, ds

	mov	cl, 4
	shr	si, cl			; # paras used by Env
	add	si, bx			; End para number

	mov	bx, word ptr cs:N_mcb	; Load our MCB address in BX
	mov	ax, bx
	inc	ax
	sub	si, ax
	mov	cx, si			; Save new max paras in CX

;
; Use interrupt 4a to shrink memory.  First release all memory above us.
;
	push	ax
	push	cx			; Save Max paras and location
	mov	ds, bx			; Set up the segement for MCB
	mov	cx, word ptr ds:3	; Get the MCB length

; Are we the only one in the chain?

	cmp	byte ptr ds:0, 'Z'	; End of chain ?
	jz	$Shrink_First

;
; Loop round releasing memory blocks
;
;	CX - original length of block;
;	DS - segement of the previous block
;
$Shrink_Next:
	mov	ax, ds			; Move to the next block
	add	cx, ax
	inc	cx
	mov	ds, cx

	cmp	byte ptr ds:0, 'Z'	; End of chain ?
	jz	$Shrink_First

	mov	cx, word ptr ds:3	; Save the length of this block

	mov	ax, ds			; Advance to the block itself
	inc	ax
	mov	es, ax			; Set up Block address

	mov	ah, 049H
	int	021H
	jmp	$Shrink_Next

;
;	Shrink the PSP segment
;

$Shrink_First:
	pop	cx
	pop	ax
        mov	es, ax			; Set PSP address
	mov	bx, cx			; Set max length
	mov	ah, 04aH
	int	021H

;
; Execute function
;

	mov	word ptr cs: S_sp, sp	; Save the current stack
	mov	word ptr cs: S_ss, ss

;
; Move to the local stack so that it doesn't get overwritten.
;
	mov	ax, cs
	cli
	mov	sp, offset Local_Stack
	mov	ss, ax
	sti

; Clear out Interrupts

	mov	ah, 00bH		; Check Keyboard status
	int	021H

;
;  Check for interrupt 23 detected
;
	mov	ax, word ptr cs:_SW_intr
	xor	ax, ax
	jz	$I23_Cf			; No - continue;

;
; Interrupt 23 detected - abort
;
	mov	ax, cs			; Set up for reload
	cli
	mov	sp, offset Local_Stack
	mov	ss, ax
	sti

	mov	ds, word ptr cs:S_ds	; Restore DS
	mov	word ptr ds:_errno, 4	; Set to EINTR
	jmp	$Exec_Error

;
; No interrupts - continue
;
$I23_Cf:
	mov	ax, cs			; Set up segments
	mov	es, ax
	mov	ds, ax

	mov	ax, 04b00H		; Load and execute function
	mov	dx, offset _path_line	; Load path
	mov	bx, offset exec_parms	; Load the execute structure
	mov	byte ptr cs:InShell, 1	; Set not In shell flag for Interrupt 23
	int	021H
	mov	byte ptr cs:InShell, 0	; Set In shell flag for Interrupt 23

; Disable interrupts while we restore the stack to the local one

	mov	ax, cs
	cli
	mov	sp, offset Local_Stack
	mov	ss, ax
	sti

;
; Did an error occur?
;
	jnc	$Exec_OK

;
; Error
;
	mov	ds, word ptr cs:S_ds	; Restore DS
	mov	ah, al
	call	far ptr __maperror	; Map the error

$Exec_Error:
	mov	ax, 0FFFFH
	jmp	$Exec_Complete

;
; No - get the exit code and check for interrupts
;

$Exec_OK:
	mov	ax, 04d00H
	int	021H
	dec	ah			; Interrupt termination ?
	jnz	$Exec_OK1

	inc	word ptr ds:_SW_intr	; Set Interrupt 23 detected.

$Exec_OK1:
	xor	ah, ah

;
; Save the result code
;

$Exec_Complete:
	mov	word ptr cs:Result, ax		; Save response

;
; Very Dangerous - Restore Environment
;
;	 Seek to 0x4000 in file
;
	mov	bx, word ptr cs:_SW_fp		; Load File Handler
	mov	ax, word ptr cs: _SW_Mode	; Skip if not disk
	dec	ax
	jnz	$Seek_OK

; Seek in file to skip 16K

	mov	dx, 04000H
	call	$Seek_Disk

;
;	 Load from N_mcb:0x4000 to end of file.
;

$Seek_OK:
	mov	si, word ptr cs:_SW_Blocks	; Load number of transfers
	dec	si				; Skip first block

;
; set up ES register with start of load
;
	mov	ax, word ptr cs:N_mcb	; Load the start address
	add	ax, 0400H
	mov	ds, ax

; load up extended memory GDT for destination

	call	$GDT_reload
	call	$Inc_Extend			; Increment addresses by 16K

;
; Check for end of copy	- BX - File Handler for disk
;

$Read_loop:
	or	si, si
	je	$Read_Complete

; OK - Copy next 0x4000 bytes - switch on device

	mov	ax, word ptr cs: _SW_Mode
	dec	ax
	jz	$R_disk
	dec	ax
	jz	$R_extend
	jmp	$R_expand

; Read from disk

$R_disk:
	call	$Read_disk
	jmp	$Read_loop

; Read from extended memory

$R_extend:
	call	$Read_extend
	jmp	$Read_loop

; Read from expanded memory

$R_expand:
	call	$Read_EMS
	jmp	$Read_loop

;
; Re-load is now complete, Restore original stack which has just been
; reloaded.  BX contains FP
;

$Read_Complete:
	cli
	mov	sp, word ptr cs: S_sp		; Save the current stack
	mov	ss, word ptr cs: S_ss
	sti

;  Save exit code

	push	word ptr cs:Result		; Save response

;
; Read in the first block - BX - File Handler
;

	mov	ax, word ptr cs: _SW_Mode	; Skip if not disk
	dec	ax
	jnz	$Seek1_OK

; Seek to 0 in file

	xor	dx, dx
	call	$Seek_Disk

;
;	 Load one block at N_mcb:0x0000
;
$Seek1_OK:
	mov	ds, word ptr cs:N_mcb		; Load the start address
	call	$GDT_reload			; Load the GDT for extend mem

	mov	ax, word ptr cs: _SW_Mode	; Skip if not disk
	dec	ax
	jz	$R1_Disk
	dec	ax
	jz	$R1_Extend
	jmp	$R1_Expand

$R1_Disk:
	call	$Read_disk
	jmp	$Read1_OK

$R1_Extend:
	call	$Read_extend
	jmp	$Read1_OK

$R1_Expand:
	mov	si, word ptr cs:_SW_Blocks	; Read first block
	call	$Read_EMS

;
; Complete - load error code and return
;

$Read1_OK:
	pop	ax

;
; Exit function - Restore Control Interrupt handler
;

$SA_spawn_Exit:
	push	ax				; Save exit code
	mov	ax, 02523H			; Set Control C Interrupt
	mov	ds, word ptr cs:_SW_I23_V_ES
	mov	dx, word ptr cs:_SW_I23_V_BX
	int	021H

	mov	ax, 02523H			; Set Divide Zero Interrupt
	mov	ds, word ptr cs:_SW_I0_V_ES
	mov	dx, word ptr cs:_SW_I0_V_BX

;

	mov	di, word ptr cs:S_di		; Restore saved registers
	mov	si, word ptr cs:S_si
	mov	ds, word ptr cs:S_ds

; If interrupt 23 detected - raise the flag

	mov	ax, word ptr cs:_SW_intr	; Set Interrupt 23 detected.
	or	ax, ax
	jz	$SA_Exit1

	mov	ax, 02H
	push	ax				; Set SIGINT
	call	_raise
	add	sp, 2

$SA_Exit1:
	pop	ax				; Restore result
	mov	sp,bp
	pop	bp
	ret

_SA_spawn	endp

;
; READ DISK FUNCTION
;
;	BX - file handler
;	SI - Block count
;	DS - Output data segement
;

$Read_disk	proc	near

	mov	ax, 03f00H		; Set up to read
	mov	cx, 04000H		; Load count
	xor	dx, dx			; Clear start address

	int	021H			; Read the data

	jnc	$Read_OK		; NO - abort
	jmp	Load_Error		; Abort - swap file error

;
; Read OK - next block
;

$Read_OK:
	dec	si			; Decrement block count
	mov	ax, ds			; Increment offset
	add	ax, 0400H
	mov	ds, ax
	ret

$Read_disk	endp

;
; READ EMS FUNCTION
;
;	BX - file handler
;	SI - Block count - counts from max
;	DS - Output data segement
;

$Read_EMS	proc	near

	call	$map_ems_page		; Map in the current EMS page
	jnz	Load_Error

	push	ds			; Save DS and SI
	push	si
	mov	ax, ds
	mov	es, ax
	mov	ds, word ptr cs:_SW_EMSFrame	; Set Dest Seg
	xor	si, si			; Clear start
	xor	di, di
	mov	cx, 02000H		; move 16K
	pushf				; Save direction flag
	cld
    rep movsw
	popf				; Restore direction flag
	pop	si			; And DS, SI
	pop	ds
	jmp	$Read_OK		; Increment DS and dec SI

$Read_EMS	endp

;
; MAP IN THE CURRENT EMS PAGE
;
;	BX - file handler
;	SI - Block count - counts from max
;	DS - Output data segement
;

$map_ems_page	proc	near

	push	bx			; Need to save BX
	mov	ax, 04400h		; Map into physical page zero
	mov	dx, bx			; Set up handler
	mov	bx, word ptr cs: _SW_Blocks
	sub	bx, si

	int	067H
	pop	bx

	or	ah, ah
	ret

$map_ems_page	endp

;
; DISK SEEK FUNCTION
;
;	BX - file handler
;	DX - offset
;
$Seek_Disk	proc	near

	mov	ax, 04200H		; Set seek
	xor	cx, cx
	int	021H
	jc	Load_Error		; Abort - swap file error
	ret

$Seek_Disk	endp

;
; PANIC - Abort
;

Load_Error	proc	near

	mov	ax, 00900H
	mov	dx, offset Swap_PANIC
	mov	bx, cs
	mov	ds, bx
	int	021H
$Wait_L:
	sti
	hlt
	jmp	$Wait_L

Load_Error	endp

;
;  WRITE EXTENDED MEMORY
;
;	SI - Block count
;
$Write_extend	proc	near

	push	si			; Save SI (block counter)
	mov	cx, 02000H		; Copy a 16K block
	mov	ax, cs			; Set up GDT address
	mov	es, ax
	mov	si, offset GD_table

	mov	ah, 087H		; EMS function
	int	015H
	pop	si
	ret

$Write_extend	endp

;
;  READ FROM EXTENDED MEMORY
;
;	SI - Block count
;

$Read_extend	proc	near

	call	$Write_extend
	jc	Load_Error		; NO - abort

	dec	si			; Decrement block count

$Read_extend	endp

;
; INCREMENT Extended MEMORY GDT
;
;	AX - used
;
$Inc_Extend	proc	near

	mov	ax, 04000H		; Increment address by 16K
	add	word ptr cs:GDT_dest_low, ax
	adc	byte ptr cs:GDT_dest_high, 0
	add	word ptr cs:GDT_src_low, ax
	adc	byte ptr cs:GDT_src_high, 0
	ret

$Inc_Extend	endp

;
; LOAD SOURCE GDT ADDRESS
;
;	AX - low order
;	DL - high order
;
$GDT_src_load	proc	near


	mov	word ptr cs:GDT_src_low, ax
	mov	byte ptr cs:GDT_src_high, dl
	ret

$GDT_src_load	endp

;
; LOAD DESTINATION GDT ADDRESS
;
;	AX - low order
;	DL - high order
;
$GDT_dest_load	proc	near

	mov	word ptr cs:GDT_dest_low, ax
	mov	byte ptr cs:GDT_dest_high, dl
	ret

$GDT_dest_load	endp

;
; LOAD the GDT for reloading
;

$GDT_reload	proc	near
	mov	ax, word ptr cs:_SW_EMstart 	; Load Full start address
	mov	dl, byte ptr cs:_SW_EMstart + 2
	call	$GDT_src_load

	mov	ax, word ptr cs:SW_LMstart 	; Load Full start address
	mov	dl, byte ptr cs:SW_LMstart + 2
	call	$GDT_dest_load
	ret
$GDT_reload	endp

;
; CONTROL C INTERRUPT HANDLER - IGNORE
;

SA_IRET		proc	far
	push	ax
	push	bp			; Save the AX and DS registers
	push	ds
	mov	bp, seg SH0_TEXT	; Get my segment
	mov	ds, bp
	inc	word ptr ds:_SW_intr	; Set Interrupt 23 detected.
	cmp	byte ptr ds:InShell, 0	; Are we in the shell ?
	jz	$SA_Ins

; In another program - move the stack around

	mov	bp, sp
	pop	ds			; Unstack values
	pop	bp
	pop	ax
	stc
	ret


; In shell - ignore interrupt 23 for the moment

$SA_Ins:
	pop	ds			; Restore regs
	pop	bp
	pop	ax
	iret

SA_IRET		endp

;
; DIVIDE BY ZERO INTERRUPT HANDLER - Output message
;

SA_DZERO	proc	far

	mov	ax, 00900H
	mov	dx, offset Swap_DZERO
	mov	bx, cs
	mov	ds, bx
	int	021H

	mov	ax, 04CFFh		; Exit
	int	021H

SA_DZERO	endp

;
;  Start of overwrite area for environment.  Align on a paragraph
;
		ALIGN	16
Env_OWrite:
SH0_TEXT	ends
		end
